<?php

if (!defined('ABSPATH'))
	exit;


Class In_Class_PandaSMS_Connect {



	public static function gonder($numaralar, $msgIcerik)
	{

		$body = [

			"veri" => [

				"kullaniciAdi"=>get_option("pandasms_username"),
				"sifre"=>get_option("pandasms_password"),
				"apiAnahtar"=>get_option("pandasms_apikey"),
				"originator"=>get_option("pandasms_originator"),
				"numaralar"=>$numaralar,
				"mesaj"=>$msgIcerik

			]

		];

		$body = wp_json_encode( $body );

		$options = [

			'body'              => $body,
			'headers'           => [
				'Content-type'  => 'application/json'
			],
			'timeout' => 60,
			'data_format'       => 'body'

		];

		$result_raw = wp_remote_post( 'https://api.pandasms.com/v3/mesajGonder', $options );


		if( !$result_raw || is_wp_error($result_raw))
			return false;

		$result = json_decode( $result_raw['body'] );

		return $result;


	}



	public static function sorgula($gonderimNo)
	{

		$body = [

			"veri"  =>  [

				"kullaniciAdi"=>get_option("pandasms_username"),
				"sifre"=>get_option("pandasms_password"),
				"apiAnahtar"=>get_option("pandasms_apikey"),
				"gonderimNo"=>$gonderimNo,
				"msgGoster"=>true,

			]

		];


		$body = wp_json_encode( $body );

		$options = [

			'body'              => $body,
			'headers'           => [
				'Content-type'  => 'application/json'
			],
			'timeout' => 60,
			'data_format'       => 'body'

		];

		$result_raw = wp_remote_post( 'https://api.pandasms.com/v3/gonderimSorgula', $options );

		if( !$result_raw || is_wp_error($result_raw))
			return false;

		$result = json_decode( $result_raw['body'] );

		return $result;


	}



}