<?php

if (!defined('ABSPATH'))
	exit;


Class In_Class_PandaSMS_Gonderim_Talebi
{


	public static function getTumTalepler(){


		global $wpdb;

		$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

		$tum_talepler = $wpdb->get_results( "SELECT * FROM $gonderim_talepleri_tablo ORDER BY talep_id DESC" );

		return $tum_talepler;


	}


	public static function getSipariseAitTalepler($order_id){

		$order_id = isset($order_id) ? intval($order_id) : 0;

		if(!$order_id)
			return;

		global $wpdb;

		$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

		$query = $wpdb->prepare( "SELECT * FROM $gonderim_talepleri_tablo WHERE wc_order_id='%s'", $order_id );

		return $wpdb->get_results( $query );


	}


	// 25 adet döndürür.
	public static function getBekleyenTalepler(){

		global $wpdb;

		$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

		$bekleyenler = $wpdb->get_results( "SELECT * FROM $gonderim_talepleri_tablo WHERE tamamlandi = 0 LIMIT 25" );

		return $bekleyenler;

	}


	public static function handle( $talep_id ){


		$talep_id = (isset($talep_id) && $talep_id > 0 ) ? $talep_id : 0;

		if(!$talep_id)
			return;


		$talep_detaylari = In_Class_PandaSMS_Gonderim_Talebi::getTalepDetaylari( $talep_id );


		if( ! isset($talep_detaylari) || $talep_detaylari->tamamlandi == 1 )
			return;


		$gonderim_yapilacak_kayitlar = In_Class_PandaSMS_Gonderim_Talebi::getGonderimler( $talep_id );

		$gonderim_yapilacak_numaralar = [];


		/**
		 *
		 * Şimdilik sadece 1 to n formatında gönderim desteklenmektedir. ( aynı mesajın n kişiye gönderimi )
		 * Gelecek versiyonlarda n to n ( n farklı mesajların n kişiye gönderilmesi ) planlanmaktadır.
		 *
		 */
		foreach( $gonderim_yapilacak_kayitlar as $detay ){


			$gonderim_yapilacak_numaralar[] = $detay->numara;


		}


		if(!count($gonderim_yapilacak_numaralar) > 0){



			// talebi başarılı olarak kaydet ve gönderim numarasını işle.

			global $wpdb;

			$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

			$wpdb->update( $gonderim_talepleri_tablo, [

				'pandasms_gonderim_id' => 0,
				'tamamlandi' => 1

			], [ 'talep_id' => $talep_id ] );


			return;


		}


		$mesaj = $talep_detaylari->mesaj;

		$sms_gonderim_detaylari = In_Class_PandaSMS_Connect::gonder($gonderim_yapilacak_numaralar, $mesaj);


		if(!$sms_gonderim_detaylari)
			return false;


		if(isset($sms_gonderim_detaylari->gonderimNo) && $sms_gonderim_detaylari->gonderimNo > 0){

			// talebi başarılı olarak kaydet ve gönderim numarasını işle.

			global $wpdb;

			$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

			$wpdb->update( $gonderim_talepleri_tablo, [

				'pandasms_gonderim_id' => $sms_gonderim_detaylari->gonderimNo,
				'tamamlandi' => 1

			], [ 'talep_id' => $talep_id ] );

		}


	}



	public static function getTalepDetaylari($talep_id){

		global $wpdb;

		$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

		$gonderim_talepleri_query = $wpdb->prepare("SELECT * FROM $gonderim_talepleri_tablo WHERE talep_id = '%s'", $talep_id);

		$gonderim_talebi = $wpdb->get_row( $gonderim_talepleri_query );

		return $gonderim_talebi;

	}


	public static function getGonderimler( $talep_id ){

		global $wpdb;

		$gonderimler_tablo = $wpdb->prefix . 'pandasms_gonderimler';

		$gonderimler_query = $wpdb->prepare("SELECT * FROM $gonderimler_tablo WHERE talep_id = '%s'", $talep_id);

		$gonderimler = $wpdb->get_results( $gonderimler_query );

		return $gonderimler;


	}


	public static function push($orderId, $islemTipi, $tetikleyiciAnahtari='', $msg, $numaralarArr)
	{

		$orderId      = isset($orderId) ? intval($orderId) : 0;
		$islemTipi    = isset($islemTipi) ? sanitize_text_field($islemTipi) : false;
		$msg          = isset($islemTipi) ? $msg : false;
		$numaralarArr = (isset($islemTipi) && count($numaralarArr) > 0) ? $numaralarArr : false;


		if (!$orderId || !$islemTipi || !$msg || !$numaralarArr)
			return;


		$temizNumaralarTemp = [];


		foreach ($numaralarArr as $numara) {


			$temizNumaralarTemp[] = In_Class_PandaSMS_Helper::telefonTemizle($numara);


		}


		// Tekrarlananları temizle

		$temizNumaralar = array_unique($temizNumaralarTemp);

		$toplamTemizNumara = count($temizNumaralar);

		if(!$toplamTemizNumara>0)
			return;

		global $wpdb;

		$gonderim_talepleri_tablo = $wpdb->prefix . 'pandasms_talepleri';

		$wpdb->insert($gonderim_talepleri_tablo, [

			'wc_order_id' => $orderId,
			'islem_tipi' => $islemTipi,
			'tetikleyici_anahtari' => $tetikleyiciAnahtari,
			'numara_adedi' => $toplamTemizNumara,
			'islem_zaman' => current_time('mysql'),
			'gonderim_tipi' => '1:n',
			'mesaj' => $msg

		]);


		$talep_id = $wpdb->insert_id;


		$gonderimler_tablo = $wpdb->prefix . 'pandasms_gonderimler';

		foreach ($temizNumaralar as $numara) {

			$wpdb->insert($gonderimler_tablo, [

				'talep_id' => $talep_id,
				'numara' => $numara,
				'mesaj' => $msg,
				'islem_zaman' => current_time('mysql')

			]);

		}



		return $talep_id;


	}


}